<template>
  <div>
    <h2 id="page-heading" data-cy="CicloActividadHeading">
      <span v-text="$t('gatewayApp.biologicoCicloActividad.home.title')" id="ciclo-actividad-heading">Ciclo Actividads</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.biologicoCicloActividad.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'CicloActividadCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-ciclo-actividad"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.biologicoCicloActividad.home.createLabel')"> Create a new Ciclo Actividad </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && cicloActividads && cicloActividads.length === 0">
      <span v-text="$t('gatewayApp.biologicoCicloActividad.home.notFound')">No cicloActividads found</span>
    </div>
    <div class="table-responsive" v-if="cicloActividads && cicloActividads.length > 0">
      <table class="table table-striped" aria-describedby="cicloActividads">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('periodoCiclo')">
              <span v-text="$t('gatewayApp.biologicoCicloActividad.periodoCiclo')">Periodo Ciclo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'periodoCiclo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('cantidad')">
              <span v-text="$t('gatewayApp.biologicoCicloActividad.cantidad')">Cantidad</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'cantidad'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fechaInicioCiclo')">
              <span v-text="$t('gatewayApp.biologicoCicloActividad.fechaInicioCiclo')">Fecha Inicio Ciclo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fechaInicioCiclo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('biologico.id')">
              <span v-text="$t('gatewayApp.biologicoCicloActividad.biologico')">Biologico</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'biologico.id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('vacuna.id')">
              <span v-text="$t('gatewayApp.biologicoCicloActividad.vacuna')">Vacuna</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'vacuna.id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.biologicoCicloActividad.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="cicloActividad in cicloActividads" :key="cicloActividad.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'CicloActividadView', params: { cicloActividadId: cicloActividad.id } }">{{
                cicloActividad.id
              }}</router-link>
            </td>
            <td>{{ cicloActividad.periodoCiclo }}</td>
            <td>{{ cicloActividad.cantidad }}</td>
            <td>{{ cicloActividad.fechaInicioCiclo ? $d(Date.parse(cicloActividad.fechaInicioCiclo), 'short') : '' }}</td>
            <td>
              <div v-if="cicloActividad.biologico">
                <router-link :to="{ name: 'BiologicoView', params: { biologicoId: cicloActividad.biologico.id } }">{{
                  cicloActividad.biologico.id
                }}</router-link>
              </div>
            </td>
            <td>
              <div v-if="cicloActividad.vacuna">
                <router-link :to="{ name: 'VacunaView', params: { vacunaId: cicloActividad.vacuna.id } }">{{
                  cicloActividad.vacuna.id
                }}</router-link>
              </div>
            </td>
            <td>
              {{ cicloActividad.user ? cicloActividad.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link
                  :to="{ name: 'CicloActividadView', params: { cicloActividadId: cicloActividad.id } }"
                  custom
                  v-slot="{ navigate }"
                >
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link
                  :to="{ name: 'CicloActividadEdit', params: { cicloActividadId: cicloActividad.id } }"
                  custom
                  v-slot="{ navigate }"
                >
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(cicloActividad)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.biologicoCicloActividad.delete.question"
          data-cy="cicloActividadDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-cicloActividad-heading" v-text="$t('gatewayApp.biologicoCicloActividad.delete.question', { id: removeId })">
          Are you sure you want to delete this Ciclo Actividad?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-cicloActividad"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeCicloActividad()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./ciclo-actividad.component.ts"></script>
